<script lang="ts" setup>
import { usePromotionStore } from "@/stores/promotion";
import { onMounted, ref } from "vue";
import type { VForm } from "vuetify/components";
const form = ref<VForm | null>(null);
const promotionStore = usePromotionStore();
async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await promotionStore.savePromotion();
  }
}

</script>
<template>
  <v-dialog v-model="promotionStore.dialog" persistent width="500">
    <v-card>
      <v-card-title>
        <span class="text-h5">เพิ่มโปรโมชัน</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-container>
            <!-- <v-row>
              <v-col cols="12">
                <v-text-field label="ชื่อสินค้า*" required v-model="promotionStore.editedPromotion.name" :rules="[
                  (v) => !!v || 'ชื่อสินค้าห้ามว่าง',
                  (v) => v.length >= 3 || 'ชื่อสินค้าต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                ]"></v-text-field>
              </v-col>
            </v-row> -->

            <v-row>
              <v-col><span>ชื่อโปรโมชัน</span></v-col>
              <v-col cols="8"><v-text-field label="ชื่อโปรโมชัน*" required v-model="promotionStore.editedPromotion.name"
                  :rules="[
                    (v) => !!v || 'ชื่อโปรโมชันห้ามว่าง',
                    (v) => v.length >= 3 || 'ชื่อโปรโมชันต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>รายละเอียด</span></v-col>
              <v-col cols="8"><v-text-field label="รายละเอียด*" required
                  v-model="promotionStore.editedPromotion.description" :rules="[
                    (v) => !!v || 'รายละเอียดห้ามว่าง',
                    (v) => v.length >= 3 || 'รายละเอียดต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>ส่วนลด</span></v-col>
              <v-col cols="8"><v-text-field label="ส่วนลด*" required v-model="promotionStore.editedPromotion.discount"
                  :rules="[
                    (v) => !!v || 'ส่วนลดห้ามว่าง'
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>ระยะเวลาเริ่มต้น</span></v-col>
              <v-col cols="8"><v-text-field label="ระยะเวลาเริ่มต้น*" type="date" required
                  v-model="promotionStore.editedPromotion.startDate" :rules="[
                    (v) => !!v || 'ระยะเวลาเริ่มต้นห้ามว่าง',
                    (v) => v.length >= 3 || 'ระยะเวลาเริ่มต้นต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                  ]"></v-text-field></v-col>
            </v-row>
            <v-row>
              <v-col><span>ระยะเวลาสิ้นสุด</span></v-col>
              <v-col cols="8"><v-text-field label="ระยะเวลาสิ้นสุด*" type="date" required
                  v-model="promotionStore.editedPromotion.endDate" :rules="[
                    (v) => !!v || 'ระยะเวลาสิ้นสุดห้ามว่าง',
                    (v) => v.length >= 3 || 'ระยะเวลาสิ้นสุดต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                  ]"></v-text-field></v-col>
            </v-row>



          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="promotionStore.dialog = false">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
      </v-card-actions>
  </v-card>
</v-dialog></template>
